import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/** This program was made by William Denniss, using exerts of code from WillPang (also by William Denniss).
 * No part may be copied without prior permission, and due credit must be given to the author of this program
 *
 *@version 18 June 2001
 * 18 June Types added!
 */
public class WillPangBallGen extends JFrame {
	

	// Program information
	public static final String PROGRAM_NAME = "WillPang BallGen";
	public static final String VERSION_NUMBER = "2.0.2b";
	public static final String DATE_CREATED = "12 June 2001";	
	public static final String DATE_UPDATED = "29 June 2001";
	public static final String AUTHOR = "William Denniss";


	public Image ballImage;
	public Options options;
	
	private JTextField text;
	private JTextField widthText;
	private JTextField heightText;
	private JTextField scaleText;
	public JFrame params;
	double scale;
	BallType types [];
	boolean done = false;
	
	private JLabel loading;
	
	public BallGenPanel ballGenPanel;
	private JPanel paramPanel;
	private JButton go;
	
	int height;	
	int width;
	
	
	public static WillTank willTankPanel = new WillTank(PROGRAM_NAME, VERSION_NUMBER, DATE_UPDATED);
	
	
	//main method
	public static void main(final String[] args) {
		willTankPanel.differWidth(+10);	
		willTankPanel.startDialog();
		final WillPangBallGen ballsFrame = new WillPangBallGen();
	//	ballsFrame.setVisible(true);
		
	}
	

	public void settings () {
		params = new JFrame();
		paramPanel = new JPanel();


		paramPanel.setLayout (new BorderLayout());//GridLayout(5,2, 5,5));

		JPanel title = new JPanel();
		title.add(new JLabel("Design Settings"));

		title.add(new JLabel("These settings are NOT saved."));
		
		JPanel settings = new JPanel();
		settings.setLayout (new GridLayout(5,2, 5,5));

		settings.add(new JLabel("Width"));
		widthText = new JTextField("640", 15);
		settings.add(widthText);
		
		settings.add(new JLabel("Height"));
		heightText = new JTextField("480", 15);
		settings.add(heightText);

		settings.add(new JLabel("Scale"));
		scaleText = new JTextField("1.3", 15);
		settings.add(scaleText);
		
		
		go = new JButton("GO");

		go.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent evt) {
				if (!done) {
					done = true;
					startApp();
				}
			}
		});
		
		loading = new JLabel("");

		params.setResizable(false);
		
		JPanel buttons = new JPanel();
		buttons.add(loading);
		buttons.add(go);
		
		paramPanel.add(title, BorderLayout.NORTH);
		paramPanel.add(settings, BorderLayout.CENTER);
		paramPanel.add(buttons, BorderLayout.SOUTH);		
		params.getContentPane().add(paramPanel);
		params.setBounds(200,200,200,200);
		params.setTitle("Editing Parameters");
		params.setVisible(true);
		params.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	public void startApp() {
	
		go.setEnabled(false);
	
		try {
			width = Integer.parseInt(widthText.getText());
		} catch (NumberFormatException e) {
			width = 650;
		}
		
		try {
			height = Integer.parseInt(heightText.getText());
		} catch (NumberFormatException e) {
			height = 480;
		}

		
		try {
			scale = Double.parseDouble(scaleText.getText());
		} catch (NumberFormatException e) {
			scale = 1.3;
		}


//		params.remove(paramPanel) ;
		//Display loading screen
		
		loading.setText("Loading ball types...");
		JPanel buttons = new JPanel();
		buttons.add(loading);
		//buttons.add(go);
		
		paramPanel = new JPanel();
		paramPanel.add(loading, BorderLayout.SOUTH);
		
		paramPanel.repaint();


		params.getContentPane().add(paramPanel);

		LoadBallGen loads = new LoadBallGen(this);
		Thread loadingThread = new Thread(loads);
		loadingThread.start();
		

		
		
	}

	public WillPangBallGen () {
		ballImage = getImage("WillPangBalls.gifs");
		
		settings();
		
		
		
		
		
	}

	public void openApp(int width, int height, double scale) {	
		
		options = new Options(this);
		options.setVisible(true);
		Thread newThread = new Thread(options);
		newThread.setPriority(Thread.MIN_PRIORITY);
		newThread.start();
		
		
	
		setTitle("WillPang BallGen");
		setBounds(320, 10, width, height);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE); //exit the application when this frame is closed
	//	setResizable(false); //don't let the user resize the frame
		
		// Load the Images
		Toolkit tk = Toolkit.getDefaultToolkit();

		ballImage = getImage("WillPangBalls.gifs");

		
		// Create a new ImagePane
		ballGenPanel = new BallGenPanel (this, scale, options);
		
		
		Container c = getContentPane();

		c.add(ballGenPanel);
		
		
		
		
	//	ballGenPanel.printAll();
	
	
	}
	
		/** Load an image file
	 * This method was desined especially for loading image files from .jar files, however it can load any image
	 */
	public Image getImage (String imagefile)  {
		Toolkit tk = Toolkit.getDefaultToolkit();
 		
		try { //		return tk.getImage(this.getClass().getResource(imagefile));
				return tk.getImage(imagefile);
		//	Delegate.doze(2000);
		//	System.out.println(newi);
		//	return newi;
		} catch (NullPointerException e) {
			System.out.println("The file: " + imagefile + " could not be found");
			return null;
		}
		
	}

	public int scaleAndRound (int number) {
		return (int) Math.round(number * scale);
	}
	public int reverseScaleAndRound (int number) {
		return (int) Math.round(number / scale);
	}



}



class LoadBallGen implements Runnable{
		
		WillPangBallGen med;
		public LoadBallGen (WillPangBallGen med) {
			this.med = med;
		}
		
		
		public void run () {
			//Load the balls		
			try {
				med.types = BallType.loadType("BallGen.wpbt", med);
			} catch (Exception e) {
				e.printStackTrace();
				System.out.println("FATAL ERROR: cann't load ball types file");
			}


			med.openApp(med.width, med.height, med.scale);
			med.params.setVisible(false);
			med.setVisible(true);
		}
}